package com.company.nfp.app.calculation.product_calculations;

import com.company.nfp.entity.enumerations.SourceGoodType;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.UUID;

@Service
public class CalcProductLastCostBySaleService {
    @Autowired
    private DataManager dataManager;

    public BigDecimal calcCostsPerDate(UUID productId, LocalDateTime date) {
        try {
            return dataManager.loadValue(
                            "SELECT e.cost FROM nfp_GoodDetail e WHERE e.good.sourceGoodType = :sourceGoodType AND " +
                                    "e.product.id = :productId AND e.good.date <= :date " +
                                    "ORDER BY e.good.date DESC",
                            BigDecimal.class)
                    .parameter("sourceGoodType", SourceGoodType.ZO_CHECK.getId())
                    .parameter("productId", productId)
                    .parameter("date", date)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}