package com.company.nfp.app.get_entity.get_current_employee;

import com.company.nfp.entity.dictionaries.employee.Employee;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class GetCurrentEmployeeService {
    @Autowired
    private DataManager dataManager;

    public Employee getCurrentEmployee(UUID userId) {
        try {
            return dataManager.load(Employee.class)
                    .query("select e from nfp_Employee e " +
                            "where e.user.id = :userId")
                    .parameter("userId", userId)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}