package com.company.nfp.app.get_entity.get_current_prro;

import com.company.nfp.app.get_entity.get_current_employee.GetCurrentEmployeeService;
import com.company.nfp.entity.dictionaries.employee.Employee;
import com.company.nfp.entity.dictionaries.prro.Prro;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class GetCurrentPrroService {
    @Autowired
    private DataManager dataManager;
    @Autowired
    private GetCurrentEmployeeService getCurrentEmployeeService;

    public Prro getCurrentPrro(UUID userId) {
        var employee = getCurrentEmployeeService.getCurrentEmployee(userId);
        var employeeId = employee.getId();
        try {
            return dataManager.load(Prro.class)
                    .query("select e from nfp_Prro e " +
                            "where e.employee.id = :employeeId")
                    .parameter("employeeId", employeeId)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}