package com.company.nfp.app.get_entity.get_main_entity;

import com.company.nfp.entity.dictionaries.firm.firm_account.FirmAccount;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class GetMainFirmAccountService {
    @Autowired
    private DataManager dataManager;

    public FirmAccount getMain(UUID firmId) {
        try {
            return dataManager.load(FirmAccount.class)
                    .query("SELECT e FROM nfp_FirmAccount e WHERE e.main = TRUE AND e.firm.id = :firmId")
                    .parameter("firmId", firmId)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}