package com.company.nfp.app.get_entity.get_product_by_barcode;

import com.company.nfp.entity.dictionaries.product.Product;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class GetProductByBarcodeService {
    @Autowired
    private DataManager dataManager;

    /**
     * Find the Product By Barcode
     * @param barcode The barcode
     * @return The found Product
     */
    public Product getProductByBarcode(String barcode) {
        try {
            return dataManager.load(Product.class)
                    .query("SELECT e FROM nfp_Product e WHERE e.barcode = :barcode")
                    .parameter("barcode", barcode)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}