package com.company.nfp.app.get_entity.get_sales_method;

import com.company.nfp.app.get_entity.get_current_shop.GetCurrentShopService;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class GetSalesMethodService {
    @Autowired
    private GetCurrentShopService getCurrentShopService;
    @Autowired
    private DataManager dataManager;

    public String getSalesMethod(UUID userId) {
        try {
            var shopId = getCurrentShopService.getCurrentShop(userId);
            return dataManager.loadValue("SELECT e.salesMethod FROM nfp_ShopOption e WHERE e.shop.id = :shopId",
                            String.class)
                    .parameter("shopId", shopId)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}