package com.company.nfp.app.import_data.from_dbf;

import com.company.nfp.app.check_db.CheckFullDbService;
import com.company.nfp.app.import_data.koatuu.CreateKoatuuOldListService;
import com.company.nfp.app.import_data.koatuu.SaveKoatuuOldEntitiesService;
import com.company.nfp.app.import_data.uktzed.CreateUktzedListService;
import com.company.nfp.app.import_data.uktzed.SaveUktzedEntitiesService;
import com.linuxense.javadbf.DBFReader;
import com.linuxense.javadbf.DBFRow;
import java.util.ArrayList;
import java.util.Objects;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ImportFromDbfService {

  @Autowired
  private GetDbfReaderService getDbfReaderService;
  @Autowired
  private GetDbfRowsService getDbfRowsService;
  @Autowired
  private CreateKoatuuOldListService createKoatuuOldListService;
  @Autowired
  private SaveKoatuuOldEntitiesService saveKoatuuOldEntitiesService;
  @Autowired
  private CheckFullDbService checkFullDbService;
  @Autowired
  private CreateUktzedListService createUktzedListService;
  @Autowired
  private SaveUktzedEntitiesService saveUktzedEntitiesService;

  public String factory(String filePath, String entityName) {

    if (!Objects.equals(checkFullDbService.checkFullDb(entityName), "Ok")) return "com.company.nfp.checkDb/full";

    String result = null;
    ArrayList<DBFRow> rows = null; // = new ArrayList<>();
    DBFReader reader = getDbfReaderService.getDbfReader(filePath);
    if (reader != null) {
      rows = getDbfRowsService.getDbfRows(reader);
    } else {
      result = "notifications.warning.invalidOperation";
    }

    switch (entityName) {
      case "KoatuuOld":
        if (rows != null) {
          var koatuuOlds = createKoatuuOldListService.createKoatuuOldList(rows);
          result = saveKoatuuOldEntitiesService.saveKoatuuOldEntities(koatuuOlds);
        } else {
          result = "notifications.warning.invalidOperation";
        }
        break;
      case "Uktzed":
        if (rows != null) {
          var uktzeds = createUktzedListService.createUktzedList(rows);
          result = saveUktzedEntitiesService.saveUktzedEntities(uktzeds);
        } else {
          result = "notifications.warning.invalidOperation";
        }
        break;
    }
    return result;
  }

}