package com.company.nfp.app.import_data.koatuu;

import com.company.nfp.entity.dictionaries.koatuu.KoatuuOld;
import com.linuxense.javadbf.DBFRow;
import io.jmix.core.DataManager;
import java.math.BigDecimal;
import java.util.ArrayList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreateKoatuuOldListService {

  @Autowired
  private DataManager dataManager;

  public ArrayList<KoatuuOld> createKoatuuOldList(ArrayList<DBFRow> rows) {
    ArrayList<KoatuuOld> list = new ArrayList<>();
    for (DBFRow row : rows) {
      var koatuuOld = dataManager.create(KoatuuOld.class);
      try {
        koatuuOld.setCode(row.getBigDecimal("CODE"));
      } catch (Exception e) {
        koatuuOld.setCode(BigDecimal.ZERO);
      }
      try {
        koatuuOld.setNum(row.getString("NUM"));
      } catch (Exception e) {
        koatuuOld.setNum("нз");
      }
      try {
        koatuuOld.setFullName(row.getString("NAME"));
      } catch (Exception e) {
        koatuuOld.setFullName("нз");
      }
      try {
        koatuuOld.setShortNum(row.getString("SHORT_NUM"));
      } catch (Exception e) {
        koatuuOld.setShortNum("нз");
      }
      try {
        koatuuOld.setShortNum(row.getString("SHORT_NUM"));
      } catch (Exception e) {
        koatuuOld.setShortNum("нз");
      }
      try {
        koatuuOld.setNumCt(row.getBigDecimal("NUM_CT"));
      } catch (Exception e) {
        koatuuOld.setNumCt(BigDecimal.ZERO);
      }
      try {
        koatuuOld.setNumCod(row.getString("NUM_COD"));
      } catch (Exception e) {
        koatuuOld.setNumCod("нз");
      }
      try {
        koatuuOld.setShortName(row.getString("NAME_COD"));
      } catch (Exception e) {
        koatuuOld.setShortName("нз");
      }
      try {
        koatuuOld.setCatCod(row.getString("CAT_COD"));
      } catch (Exception e) {
        koatuuOld.setCatCod("нз");
      }
      list.add(koatuuOld);
    }
    return list;
  }

}