package com.company.nfp.app.numbwer_in_words;

import com.github.moneytostr.MoneyToStr;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Locale;

@Service
public class NumbersInWordsService {

    public String dateToString(LocalDateTime date) {
        var locale = new Locale("uk", "UA");
        if (date != null) return date.format(DateTimeFormatter.ofPattern("dd MMMM uuuu", locale));
        else return LocalDateTime.now().format(DateTimeFormatter.ofPattern("dd MMMM uuuu", locale));
    }

    public String moneyToStr(BigDecimal number) {
        try {
            var currency = MoneyToStr.Currency.UAH;
            var lang = MoneyToStr.Language.UKR;
            var moneyToStr = new MoneyToStr(currency, lang, MoneyToStr.Pennies.NUMBER);
            return moneyToStr.convert(number.doubleValue());
        } catch (Exception e) {
            return e.getLocalizedMessage();
        }
    }
}