package com.company.nfp.app.prro.get_prro_state;

import com.company.nfp.app.prro.helpers.GetResponseService;
import com.company.nfp.app.prro.helpers.UrlStringCreateService;
import com.company.nfp.entity.not_persistent.prro.PrroStateEntity;
import com.google.gson.Gson;
import com.google.gson.JsonSyntaxException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.UUID;

@Service
public class GetPrroStateService {
    @Autowired
    private UrlStringCreateService urlStringCreateService;
    @Autowired
    private GetResponseService getResponseService;

    public PrroStateEntity getState(UUID userId) throws IOException, InterruptedException {
        try {
            var urlString = urlStringCreateService.urlStringCreate(userId,"innovate/getstate");
            var response = getResponseService.getResponse(urlString);
            var gson = new Gson();
            var prroStateEntity = gson.fromJson(response.body(), PrroStateEntity.class);
            prroStateEntity.setStatus(response.statusCode());
            return prroStateEntity;
        } catch (IOException | InterruptedException | JsonSyntaxException e) {
            return null;
        }
    }
}