package com.company.nfp.app.prro.helpers;

import com.company.nfp.entity.dictionaries.prro.Prro;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class GetPrroByUserService {
    @Autowired
    private DataManager dataManager;

    public Prro getPrro(UUID userId) {
        try {
            return dataManager.load(Prro.class)
                    .query("select e from nfp_Prro e " +
                            "where e.employee.user.id = :userId")
                    .parameter("userId", userId)
                    .one();
        } catch (Exception e) {
            return null;
        }
    }
}