package com.company.nfp.app.prro.helpers;

import com.company.nfp.entity.not_persistent.prro.SaleReturnReceiptEntity;
import com.google.gson.Gson;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

@Service
public class GetResponseService {
    @Autowired
    private DataManager dataManager;

    public SaleReturnReceiptEntity getResponse(String body, String urlString) throws IOException, InterruptedException {
        var gson = new Gson();
        var client = HttpClient.newBuilder().build();
        var request = HttpRequest.newBuilder().POST(HttpRequest.BodyPublishers.ofString(body))
                .uri(URI.create(urlString))
                .header("Content-Type", "application/json;charset=utf-8")
                .build();
        var response = client.send(request, HttpResponse.BodyHandlers.ofString());
        if (response.statusCode() == 200) {
            var saleReturnReceiptEntity = gson.fromJson(response.body(), SaleReturnReceiptEntity.class);
            saleReturnReceiptEntity.setStatus(response.statusCode());
            return saleReturnReceiptEntity;
        } else {
            var saleReturnReceiptEntity = dataManager.create(SaleReturnReceiptEntity.class);
            saleReturnReceiptEntity.setStatus(response.statusCode());
            saleReturnReceiptEntity.setText("Error");
            return saleReturnReceiptEntity;
        }
    }

    public HttpResponse<String> getResponse(String urlString) throws IOException, InterruptedException {
        var client = HttpClient.newBuilder().build();
        var request = HttpRequest.newBuilder().uri(URI.create(urlString)).build();
        var response = client.send(request, HttpResponse.BodyHandlers.ofString());
        return response;
    }
}