package com.company.nfp.app.prro.send_email;

import io.jmix.email.EmailAttachment;
import io.jmix.email.EmailInfoBuilder;
import io.jmix.email.Emailer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

@Service
public class SendEmailService {
    @Autowired
    private Emailer emailer;

    public Boolean sendByEmail(String address, String caption, String pathAttacment) throws IOException {
        try {
            var pdfPath = Paths.get("c:\\prro\\receipt.pdf");
            var pdf = Files.readAllBytes(pdfPath);
            var fileName = "check.pdf";
            var emailAttachment = new EmailAttachment(pdf, fileName, caption);
            var emailInfo = EmailInfoBuilder.create()
                    .setAddresses(address)
                    .setSubject(caption)
                    .setBody("test body")
                    //.setTemplatePath(templatePath)
                    .setAttachments(emailAttachment)
                    .build();
            emailer.sendEmailAsync(emailInfo);
            return true;
        } catch (IOException e) {
            return false;
        }
    }
}