package com.company.nfp.app.set_next_number;

import com.company.nfp.app.get_entity.get_current_firm.GetCurrentFirmService;
import com.company.nfp.entity.dictionaries.firm.Firm;
import com.company.nfp.entity.enumerations.SourceGoodType;
import io.jmix.data.Sequence;
import io.jmix.data.Sequences;
import io.jmix.multitenancy.core.TenantProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.UUID;

@Service
public class SetNextNumberService {
    @Autowired
    private GetCurrentFirmService getCurrentFirmService;
    @Autowired
    private Sequences sequences;
    @Autowired
    private TenantProvider tenantProvider;

    public Long setDocumentNumber(SourceGoodType sourceGoodType, UUID userId) {
        String type = sourceGoodType.getId();
        Firm firm = getCurrentFirmService.getCurrentFirm(userId);
        String firmEdrpou = firm.getTaxNumber();
        String idSequence = "edrpou_" + firmEdrpou.trim() + "_" + type.trim();
        return sequences.createNextValue(Sequence.withName(idSequence));
    }

    public Long setTaxInvoiceNumber(LocalDate date, UUID userId) {
        Firm firm = getCurrentFirmService.getCurrentFirm(userId);
        boolean isVatPayer = firm.getIsVatPayer();
        if (isVatPayer) {
            int year = date.getYear();
            int month = date.getMonthValue();
            String edrpou = firm.getTaxNumber();
            String idSequence = "edrpou_" + edrpou.trim() + "_"
                    + Integer.toString(year).trim() + "_"
                    + Integer.toString(month).trim();
            return sequences.createNextValue(Sequence.withName(idSequence));
        } else {
            return null;
        }
    }

    public Long setProductCode() {
        String currentTenantId = tenantProvider.getCurrentUserTenantId();
        String idSequence = currentTenantId.trim() + "_product_number";
        return sequences.createNextValue(Sequence.withName(idSequence));
    }
}