package com.company.nfp.entity;

import com.company.nfp.entity.dictionaries.firm.Firm;
import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.annotation.TenantId;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import java.time.LocalDate;
import java.util.Date;
import java.util.UUID;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

@JmixEntity
@Table(name = "NFP_REG_EUS_PAYER")
@Entity(name = "nfp_RegEusPayer")
public class RegEusPayer {

  @JmixGeneratedValue
  @Column(name = "ID", nullable = false)
  @Id
  private UUID id;

  @TenantId
  @Column(name = "TENANT_ATTRIBUTE")
  private String tenantAttribute;

  @ManyToOne(fetch = FetchType.LAZY, optional = false)
  @JoinColumn(name = "FIRM_ID", nullable = false)
  private Firm firm;

  @Column(name = "VERSION", nullable = false)
  @Version
  private Integer version;

  @CreatedBy
  @Column(name = "CREATED_BY")
  private String createdBy;

  @CreatedDate
  @Column(name = "CREATED_DATE")
  @Temporal(TemporalType.TIMESTAMP)
  private Date createdDate;

  @LastModifiedBy
  @Column(name = "LAST_MODIFIED_BY")
  private String lastModifiedBy;

  @LastModifiedDate
  @Column(name = "LAST_MODIFIED_DATE")
  @Temporal(TemporalType.TIMESTAMP)
  private Date lastModifiedDate;

  @DeletedBy
  @Column(name = "DELETED_BY")
  private String deletedBy;

  @DeletedDate
  @Column(name = "DELETED_DATE")
  @Temporal(TemporalType.TIMESTAMP)
  private Date deletedDate;

  @Column(name = "REG_DATE")
  private LocalDate regDate;

  @InstanceName
  @Column(name = "REG_NUMBER_EUS_PAYER")
  private String regNumberEusPayer;

  @Column(name = "RISK_CLASS_PRODUCTION")
  private String riskClassProduction;

  @Column(name = "KVED_ASSIGNED")
  private String kvedAssigned;

  @Column(name = "DE_REG_DATE")
  private LocalDate deRegDate;

  public void setDeRegDate(LocalDate deRegDate) {
    this.deRegDate = deRegDate;
  }

  public LocalDate getDeRegDate() {
    return deRegDate;
  }

  public void setKvedAssigned(String kvedAssigned) {
    this.kvedAssigned = kvedAssigned;
  }

  public String getKvedAssigned() {
    return kvedAssigned;
  }

  public void setRiskClassProduction(String riskClassProduction) {
    this.riskClassProduction = riskClassProduction;
  }

  public String getRiskClassProduction() {
    return riskClassProduction;
  }

  public void setRegNumberEusPayer(String regNumberEusPayer) {
    this.regNumberEusPayer = regNumberEusPayer;
  }

  public String getRegNumberEusPayer() {
    return regNumberEusPayer;
  }

  public void setRegDate(LocalDate regDate) {
    this.regDate = regDate;
  }

  public LocalDate getRegDate() {
    return regDate;
  }

  public void setFirm(Firm firm) {
    this.firm = firm;
  }

  public Firm getFirm() {
    return firm;
  }

  public void setTenantAttribute(String tenantAttribute) {
    this.tenantAttribute = tenantAttribute;
  }

  public String getTenantAttribute() {
    return tenantAttribute;
  }

  public Date getDeletedDate() {
    return deletedDate;
  }

  public void setDeletedDate(Date deletedDate) {
    this.deletedDate = deletedDate;
  }

  public String getDeletedBy() {
    return deletedBy;
  }

  public void setDeletedBy(String deletedBy) {
    this.deletedBy = deletedBy;
  }

  public Date getLastModifiedDate() {
    return lastModifiedDate;
  }

  public void setLastModifiedDate(Date lastModifiedDate) {
    this.lastModifiedDate = lastModifiedDate;
  }

  public String getLastModifiedBy() {
    return lastModifiedBy;
  }

  public void setLastModifiedBy(String lastModifiedBy) {
    this.lastModifiedBy = lastModifiedBy;
  }

  public Date getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(Date createdDate) {
    this.createdDate = createdDate;
  }

  public String getCreatedBy() {
    return createdBy;
  }

  public void setCreatedBy(String createdBy) {
    this.createdBy = createdBy;
  }

  public Integer getVersion() {
    return version;
  }

  public void setVersion(Integer version) {
    this.version = version;
  }

  public UUID getId() {
    return id;
  }

  public void setId(UUID id) {
    this.id = id;
  }
}