package com.company.nfp.entity.dictionaries.counterparty;

import com.company.nfp.entity.dictionaries.counterparty.counterparty_account.CounterpartyAccount;
import com.company.nfp.entity.mapped_super_class.TenantRequisite;
import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import java.util.List;

@JmixEntity
@Table(name = "NFP_COUNTERPARTY")
@Entity(name = "nfp_Counterparty")
public class Counterparty extends TenantRequisite {

  @Composition
  @OnDelete(DeletePolicy.CASCADE)
  @OneToMany(mappedBy = "counterparty")
  private List<CounterpartyAccount> counterpartyAccounts;

  @Column(name = "FOR_RECEIPT")
  private Boolean forReceipt;

  public Boolean getForReceipt() {
    return forReceipt;
  }

  public void setForReceipt(Boolean forReceipt) {
    this.forReceipt = forReceipt;
  }

  public void setCounterpartyAccounts(
      List<CounterpartyAccount> counterpartyAccounts) {
    this.counterpartyAccounts = counterpartyAccounts;
  }

  public List<CounterpartyAccount> getCounterpartyAccounts() {
    return counterpartyAccounts;
  }

  @InstanceName
  @DependsOnProperties({"fullName"})
  public String getInstanceName() {
    return String.format("%s", getFullName());
  }
}