package com.company.nfp.entity.dictionaries.dpi;

import com.company.nfp.entity.dictionaries.firm.Firm;
import com.company.nfp.entity.mapped_super_class.Named;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_DPI")
@Entity(name = "nfp_Dpi")
public class Dpi extends Named {

  @Column(name = "DPI_CODE")
  private String dpiCode;

  @Column(name = "EDRPOU")
  private String edrpou;

  @OneToMany(mappedBy = "dpi")
  private List<Firm> firms;

  public void setEdrpou(String edrpou) {
    this.edrpou = edrpou;
  }

  public String getEdrpou() {
    return edrpou;
  }

  public void setFirms(List<Firm> firms) {
    this.firms = firms;
  }

  public List<Firm> getFirms() {
    return firms;
  }

  public void setDpiCode(String dpiCode) {
    this.dpiCode = dpiCode;
  }

  public String getDpiCode() {
    return dpiCode;
  }

  @InstanceName
  @DependsOnProperties({"dpiCode", "fullName"})
  public String getInstanceName() {
    return String.format("%s::%s",getDpiCode(), getFullName());
  }
}