package com.company.nfp.entity.dictionaries.employee;

import com.company.nfp.entity.User;
import com.company.nfp.entity.dictionaries.employee.income_signs.IncomeSigns;
import com.company.nfp.entity.dictionaries.employee.insured_person_categories.IPCategory;
import com.company.nfp.entity.dictionaries.employee.position.Position;
import com.company.nfp.entity.dictionaries.firm.Shop;
import com.company.nfp.entity.dictionaries.prro.Prro;
import com.company.nfp.entity.mapped_super_class.TenantNamed;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import java.math.BigDecimal;

@JmixEntity
@Table(name = "NFP_EMPLOYEE", indexes = {
        @Index(name = "IDX_NFP_EMPLOYEE_SHOP", columnList = "SHOP_ID"),
        @Index(name = "IDX_NFP_EMPLOYEE_USER", columnList = "USER_ID"),
        @Index(name = "IDX_NFP_EMPLOYEE_POSITION", columnList = "POSITION_ID"),
        @Index(name = "IDX_NFP_EMPLOYEE_INCOME_SIGNS", columnList = "INCOME_SIGNS_ID"),
        @Index(name = "IDX_NFP_EMPLOYEE_IP_CAT", columnList = "IP_CAT_ID")
})
@Entity(name = "nfp_Employee")
public class Employee extends TenantNamed {


    @JoinColumn(name = "SHOP_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Shop shop;

    @JoinColumn(name = "USER_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private User user;

    @JoinColumn(name = "POSITION_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Position position;

    @JoinColumn(name = "INCOME_SIGNS_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private IncomeSigns incomeSigns;

    @JoinColumn(name = "IP_CAT_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private IPCategory ipCat;

    @Column(name = "ID_NUM")
    private String idNum;

    @Column(name = "PHONE")
    private String phone;

    @Column(name = "ADDRESS")
    private String address;

    @Column(name = "SALARY", precision = 19, scale = 2)
    private BigDecimal salary;

    @Column(name = "MAIN")
    private Boolean main;
    @OneToOne(fetch = FetchType.LAZY, mappedBy = "employee")
    private Prro prro;

    public Prro getPrro() {
        return prro;
    }

    public void setPrro(Prro prro) {
        this.prro = prro;
    }

    public Boolean getMain() {
        return main;
    }

    public void setMain(Boolean main) {
        this.main = main;
    }

    public BigDecimal getSalary() {
        return salary;
    }

    public void setSalary(BigDecimal salary) {
        this.salary = salary;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getIdNum() {
        return idNum;
    }

    public void setIdNum(String idNum) {
        this.idNum = idNum;
    }

    public IPCategory getIpCat() {
        return ipCat;
    }

    public void setIpCat(IPCategory ipCat) {
        this.ipCat = ipCat;
    }

    public IncomeSigns getIncomeSigns() {
        return incomeSigns;
    }

    public void setIncomeSigns(IncomeSigns incomeSigns) {
        this.incomeSigns = incomeSigns;
    }

    public Position getPosition() {
        return position;
    }

    public void setPosition(Position position) {
        this.position = position;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Shop getShop() {
        return shop;
    }

    public void setShop(Shop shop) {
        this.shop = shop;
    }

    @InstanceName
    @DependsOnProperties({"fullName"})
    public String getInstanceName() {
        return String.format("%s", getFullName());
    }
}