package com.company.nfp.entity.dictionaries.employee.income_signs;

import com.company.nfp.entity.mapped_super_class.Attribute;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Lob;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.time.LocalDate;

@JmixEntity
@Table(name = "NFP_INCOME_SIGNS")
@Entity(name = "nfp_IncomeSigns")
public class IncomeSigns extends Attribute {

    @NotNull
    @InstanceName
    @Lob
    @Column(name = "FULL_NAME", nullable = false)
    private String fullName;

    @Column(name = "SHORT_NAME")
    private String shortName;

    @Column(name = "CODE")
    private Integer code;

    @Column(name = "NUM")
    private Integer num;

    @Column(name = "DATE_BEG")
    private LocalDate dateBeg;

    @Column(name = "DATE_END")
    private LocalDate dateEnd;

    @Column(name = "DATE_ETALON")
    private LocalDate dateEtalon;

    public void setFullName(String fullName) {
        this.fullName = fullName;
    }

    public String getFullName() {
        return fullName;
    }

    public void setDateEtalon(LocalDate dateEtalon) {
        this.dateEtalon = dateEtalon;
    }

    public LocalDate getDateEtalon() {
        return dateEtalon;
    }

    public void setDateEnd(LocalDate dateEnd) {
        this.dateEnd = dateEnd;
    }

    public LocalDate getDateEnd() {
        return dateEnd;
    }

    public void setDateBeg(LocalDate dateBeg) {
        this.dateBeg = dateBeg;
    }

    public LocalDate getDateBeg() {
        return dateBeg;
    }

    public void setNum(Integer num) {
        this.num = num;
    }

    public Integer getNum() {
        return num;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    public Integer getCode() {
        return code;
    }

    public String getShortName() {
        return shortName;
    }

    public void setShortName(String shortName) {
        this.shortName = shortName;
    }
}