package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.dictionaries.kved.Kved;
import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_FIRM_KVED", indexes = {
    @Index(name = "IDX_NFP_FIRM_KVED_FIRM", columnList = "FIRM_ID")
})
@Entity(name = "nfp_FirmKved")
public class FirmKved extends TenantAttribute {

  @JoinColumn(name = "FIRM_ID", nullable = false)
  @ManyToOne(fetch = FetchType.LAZY, optional = false)
  private Firm firm;

  @Column(name = "MAIN")
  private Boolean main;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "kved_id")
  private Kved kved;

  public Kved getKved() {
    return kved;
  }

  public void setKved(Kved kved) {
    this.kved = kved;
  }


  public void setMain(Boolean main) {
    this.main = main;
  }

  public Boolean getMain() {
    return main;
  }

  public Firm getFirm() {
    return firm;
  }

  public void setFirm(Firm firm) {
    this.firm = firm;
  }

}