package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;
import java.math.BigDecimal;
import java.time.LocalDate;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_REG_SINGLE_TAX_PAYER")
@Entity(name = "nfp_RegSingleTaxPayer")
public class RegSingleTaxPayer extends TenantAttribute {

  @InstanceName
  @Column(name = "TO_SIMPLE_TAX_DATE")
  private LocalDate toSimpleTaxDate;

  @Column(name = "GROUP_")
  private String group;

  @NumberFormat(pattern = "#,##0.00")
  @Column(name = "RATE")
  private BigDecimal rate;

  @Column(name = "CANCELLATION_DATE")
  private LocalDate cancellationDate;

  @ManyToOne(fetch = FetchType.LAZY, optional = false)
  @JoinColumn(name = "FIRM_ID", nullable = false)
  private Firm firm;

  public void setFirm(Firm firm) {
    this.firm = firm;
  }

  public Firm getFirm() {
    return firm;
  }

  public void setCancellationDate(LocalDate cancellationDate) {
    this.cancellationDate = cancellationDate;
  }

  public LocalDate getCancellationDate() {
    return cancellationDate;
  }

  public void setRate(BigDecimal rate) {
    this.rate = rate;
  }

  public BigDecimal getRate() {
    return rate;
  }

  public void setGroup(String group) {
    this.group = group;
  }

  public String getGroup() {
    return group;
  }

  public void setToSimpleTaxDate(LocalDate toSimpleTaxDate) {
    this.toSimpleTaxDate = toSimpleTaxDate;
  }

  public LocalDate getToSimpleTaxDate() {
    return toSimpleTaxDate;
  }
}