package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.metamodel.annotation.JmixEntity;
import java.time.LocalDate;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_REG_VAT_PAYER")
@Entity(name = "nfp_RegVatPayer")
public class RegVatPayer extends TenantAttribute {

  @Column(name = "IPN")
  private String ipn;

  @Column(name = "TAXPAYER_REG_DATE")
  private LocalDate taxpayerRegDate;

  @Column(name = "REG_PERIOD")
  private String regPeriod;

  @Column(name = "CANCELLATION_REG_DATE")
  private LocalDate cancellationRegDate;

  @Column(name = "CANCELLATION_REASON")
  @Lob
  private String cancellationReason;

  @Column(name = "ANNULMENT_REASON")
  @Lob
  private String annulmentReason;

  @Column(name = "REG_SPECIAL_REGIME_DATE")
  private LocalDate regSpecialRegimeDate;

  @JoinColumn(name = "FIRM_ID", nullable = false)
  @ManyToOne(fetch = FetchType.LAZY, optional = false)
  private Firm firm;

  public Firm getFirm() {
    return firm;
  }

  public void setFirm(Firm firm) {
    this.firm = firm;
  }

  public LocalDate getRegSpecialRegimeDate() {
    return regSpecialRegimeDate;
  }

  public void setRegSpecialRegimeDate(LocalDate regSpecialRegimeDate) {
    this.regSpecialRegimeDate = regSpecialRegimeDate;
  }

  public String getAnnulmentReason() {
    return annulmentReason;
  }

  public void setAnnulmentReason(String annulmentReason) {
    this.annulmentReason = annulmentReason;
  }

  public String getCancellationReason() {
    return cancellationReason;
  }

  public void setCancellationReason(String cancellationReason) {
    this.cancellationReason = cancellationReason;
  }

  public LocalDate getCancellationRegDate() {
    return cancellationRegDate;
  }

  public void setCancellationRegDate(LocalDate cancellationRegDate) {
    this.cancellationRegDate = cancellationRegDate;
  }

  public String getRegPeriod() {
    return regPeriod;
  }

  public void setRegPeriod(String regPeriod) {
    this.regPeriod = regPeriod;
  }

  public LocalDate getTaxpayerRegDate() {
    return taxpayerRegDate;
  }

  public void setTaxpayerRegDate(LocalDate taxpayerRegDate) {
    this.taxpayerRegDate = taxpayerRegDate;
  }

  public String getIpn() {
    return ipn;
  }

  public void setIpn(String ipn) {
    this.ipn = ipn;
  }

}