package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.dictionaries.acquirer.Acquirer;
import com.company.nfp.entity.dictionaries.koatuu.Koatuu;
import com.company.nfp.entity.dictionaries.koatuu.KoatuuOld;
import com.company.nfp.entity.dictionaries.model_name.ModelName;
import com.company.nfp.entity.dictionaries.software_version.SoftwareVersion;
import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import java.time.LocalDate;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_RRO", indexes = {
    @Index(name = "IDX_NFP_RRO_FIRM", columnList = "FIRM_ID")
})
@Entity(name = "nfp_Rro")
public class Rro extends TenantAttribute {

  @JoinColumn(name = "FIRM_ID", nullable = false)
  @ManyToOne(fetch = FetchType.LAZY, optional = false)
  private Firm firm;

  @Column(name = "FACTORY_NUMBER")
  private String factoryNumber;

  @InstanceName
  @Column(name = "FISCAL_NUMBER")
  private String fiscalNumber;

  @Column(name = "REGISTRATION_DATE")
  private LocalDate registrationDate;

  @Column(name = "APPLICATION_SCOPE")
  private String applicationScope;

  @Column(name = "LAST_BOOK_NUMBER")
  private String lastBookNumber;

  @Column(name = "LAST_BOOK_REGISTRATION_DATE")
  private LocalDate lastBookRegistrationDate;

  @Column(name = "CANCELLATION_REGISTRATION_DATE")
  private LocalDate cancellationRegistrationDate;

  @Column(name = "OBJECT_NAME")
  private String objectName;

  @Column(name = "OBJECT_ADDRESS")
  private String objectAddress;

  @Column(name = "MANUFACTURE_DATE")
  private LocalDate manufactureDate;

  @Column(name = "COMMISSIONING_DATE")
  private LocalDate commissioningDate;

  @Column(name = "EXPIRY_DATE")
  private LocalDate expiryDate;

  @Column(name = "NOTE")
  private String note;

  @Column(name = "NOTE1")
  private String note1;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "ACQUIRER_ID")
  private Acquirer acquirer;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "SOFTWAREVERSION_ID")
  private SoftwareVersion softwareVersion;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "MODELNAME_ID")
  private ModelName modelName;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "koatuu_id")
  private Koatuu koatuu;

  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "koatuu_old_id")
  private KoatuuOld koatuuOld;

  public KoatuuOld getKoatuuOld() {
    return koatuuOld;
  }

  public void setKoatuuOld(KoatuuOld koatuuOld) {
    this.koatuuOld = koatuuOld;
  }

  public Koatuu getKoatuu() {
    return koatuu;
  }

  public void setKoatuu(Koatuu koatuu) {
    this.koatuu = koatuu;
  }

  public void setModelName(ModelName modelName) {
    this.modelName = modelName;
  }

  public ModelName getModelName() {
    return modelName;
  }

  public void setSoftwareVersion(
      SoftwareVersion softwareVersion) {
    this.softwareVersion = softwareVersion;
  }

  public SoftwareVersion getSoftwareVersion() {
    return softwareVersion;
  }

  public void setAcquirer(Acquirer acquirer) {
    this.acquirer = acquirer;
  }

  public Acquirer getAcquirer() {
    return acquirer;
  }

  public void setNote1(String note1) {
    this.note1 = note1;
  }

  public String getNote1() {
    return note1;
  }

  public void setNote(String note) {
    this.note = note;
  }

  public String getNote() {
    return note;
  }

  public void setExpiryDate(LocalDate expiryDate) {
    this.expiryDate = expiryDate;
  }

  public LocalDate getExpiryDate() {
    return expiryDate;
  }

  public void setCommissioningDate(LocalDate commissioningDate) {
    this.commissioningDate = commissioningDate;
  }

  public LocalDate getCommissioningDate() {
    return commissioningDate;
  }

  public void setManufactureDate(LocalDate manufactureDate) {
    this.manufactureDate = manufactureDate;
  }

  public LocalDate getManufactureDate() {
    return manufactureDate;
  }

  public void setFactoryNumber(String factoryNumber) {
    this.factoryNumber = factoryNumber;
  }

  public String getFactoryNumber() {
    return factoryNumber;
  }

  public void setObjectAddress(String objectAddress) {
    this.objectAddress = objectAddress;
  }

  public String getObjectAddress() {
    return objectAddress;
  }

  public void setObjectName(String objectName) {
    this.objectName = objectName;
  }

  public String getObjectName() {
    return objectName;
  }

  public LocalDate getCancellationRegistrationDate() {
    return cancellationRegistrationDate;
  }

  public void setCancellationRegistrationDate(LocalDate cancellationRegistrationDate) {
    this.cancellationRegistrationDate = cancellationRegistrationDate;
  }

  public LocalDate getLastBookRegistrationDate() {
    return lastBookRegistrationDate;
  }

  public void setLastBookRegistrationDate(LocalDate lastBookRegistrationDate) {
    this.lastBookRegistrationDate = lastBookRegistrationDate;
  }

  public String getLastBookNumber() {
    return lastBookNumber;
  }

  public void setLastBookNumber(String lastBookNumber) {
    this.lastBookNumber = lastBookNumber;
  }

  public String getApplicationScope() {
    return applicationScope;
  }

  public void setApplicationScope(String applicationScope) {
    this.applicationScope = applicationScope;
  }

  public LocalDate getRegistrationDate() {
    return registrationDate;
  }

  public void setRegistrationDate(LocalDate registrationDate) {
    this.registrationDate = registrationDate;
  }

  public String getFiscalNumber() {
    return fiscalNumber;
  }

  public void setFiscalNumber(String fiscalNumber) {
    this.fiscalNumber = fiscalNumber;
  }

  public Firm getFirm() {
    return firm;
  }

  public void setFirm(Firm firm) {
    this.firm = firm;
  }

}