package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.dictionaries.employee.Employee;
import com.company.nfp.entity.mapped_super_class.TenantNamed;
import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import java.util.List;

@JmixEntity
@Table(name = "NFP_SHOP", indexes = {
        @Index(name = "IDX_NFP_SHOP_FIRM", columnList = "FIRM_ID")
})
@Entity(name = "nfp_Shop")
public class Shop extends TenantNamed {
    @JoinColumn(name = "FIRM_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Firm firm;

    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "shop")
    private List<Employee> employees;

    @Column(name = "ADDRESS")
    private String address;

    @Column(name = "MAIN")
    private Boolean main;

    public Boolean getMain() {
        return main;
    }

    public void setMain(Boolean main) {
        this.main = main;
    }

    public List<Employee> getEmployees() {
        return employees;
    }

    public void setEmployees(List<Employee> employees) {
        this.employees = employees;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getAddress() {
        return address;
    }

    public Firm getFirm() {
        return firm;
    }

    public void setFirm(Firm firm) {
        this.firm = firm;
    }

    @InstanceName
    @DependsOnProperties({"fullName"})
    public String getInstanceName() {
        return String.format("%s", getFullName());
    }
}