package com.company.nfp.entity.dictionaries.firm;

import com.company.nfp.entity.enumerations.SalesMethod;
import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

@JmixEntity
@Table(name = "NFP_SHOP_OPTION", indexes = {
        @Index(name = "IDX_NFP_SHOP_OPTION_SHOP", columnList = "SHOP_ID")
})
@Entity(name = "nfp_ShopOption")
public class ShopOption extends TenantAttribute {
    @NotNull
    @JoinColumn(name = "SHOP_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Shop shop;

    @Column(name = "SALES_METHOD", nullable = false)
    @NotNull
    private String salesMethod;

    public SalesMethod getSalesMethod() {
        return salesMethod == null ? null : SalesMethod.fromId(salesMethod);
    }

    public void setSalesMethod(SalesMethod salesMethod) {
        this.salesMethod = salesMethod == null ? null : salesMethod.getId();
    }

    public Shop getShop() {
        return shop;
    }

    public void setShop(Shop shop) {
        this.shop = shop;
    }
}