package com.company.nfp.entity.dictionaries.firm.firm_account;

import com.company.nfp.entity.dictionaries.bank.Bank;
import com.company.nfp.entity.dictionaries.firm.Firm;
import com.company.nfp.entity.enumerations.BankCooperation;
import com.company.nfp.entity.mapped_super_class.TenantAccount;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;

@JmixEntity
@Table(name = "NFP_FIRM_ACCOUNT", indexes = {
        @Index(name = "IDX_NFP_FIRM_ACCOUNT_BANK", columnList = "BANK_ID"),
        @Index(name = "IDX_NFP_FIRM_ACCOUNT_FIRM", columnList = "FIRM_ID")
})
@Entity(name = "nfp_FirmAccount")
public class FirmAccount extends TenantAccount {
    @Column(name = "BANK_COOPERATION")
    private String bankCooperation;

    @JoinColumn(name = "BANK_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Bank bank;

    @Column(name = "USER_ID")
    private String userId;

    @Lob
    @Column(name = "ACCESS_TOKEN")
    private String accessToken;

    @JoinColumn(name = "FIRM_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Firm firm;

    public Firm getFirm() {
        return firm;
    }

    public void setFirm(Firm firm) {
        this.firm = firm;
    }

    public Bank getBank() {
        return bank;
    }

    public void setBank(Bank bank) {
        this.bank = bank;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public BankCooperation getBankCooperation() {
        return bankCooperation == null ? null : BankCooperation.fromId(bankCooperation);
    }

    public void setBankCooperation(BankCooperation bankCooperation) {
        this.bankCooperation = bankCooperation == null ? null : bankCooperation.getId();
    }

    @InstanceName
    @DependsOnProperties({"firm", "account", "bank"})
    public String getInstanceName() {
        return String.format("%s :: %s :: %s", firm.getFullName() ,getAccount(), bank.getFullName());
    }
}