package com.company.nfp.entity.dictionaries.koatuu;

import com.company.nfp.entity.dictionaries.firm.Rro;
import com.company.nfp.entity.mapped_super_class.Named;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import java.math.BigDecimal;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@JmixEntity
@Table(name = "NFP_KOATUU_OLD")
@Entity(name = "nfp_KoatuuOld")
public class KoatuuOld extends Named {

  @Column(name = "CODE")
  private BigDecimal code;

  /**
   * КОАТУУ
   */
  @Column(name = "NUM")
  private String num;

  @Column(name = "SHORT_NUM")
  private String shortNum;

  @Column(name = "NUM_CT")
  private BigDecimal numCt;


  /**
   * КАТОТТГ
   */
  @Column(name = "NUM_COD")
  private String numCod;

  /**
   * Категорія
   */
  @Column(name = "CAT_COD")
  private String catCod;

  @OneToMany(mappedBy = "koatuuOld")
  private List<Rro> rros;

  public void setRros(List<Rro> rros) {
    this.rros = rros;
  }

  public List<Rro> getRros() {
    return rros;
  }

  public void setCatCod(String catCod) {
    this.catCod = catCod;
  }

  public String getCatCod() {
    return catCod;
  }

  public void setNumCod(String numCod) {
    this.numCod = numCod;
  }

  public String getNumCod() {
    return numCod;
  }

  public void setNumCt(BigDecimal numCt) {
    this.numCt = numCt;
  }

  public BigDecimal getNumCt() {
    return numCt;
  }

  public void setShortNum(String shortNum) {
    this.shortNum = shortNum;
  }

  public String getShortNum() {
    return shortNum;
  }

  public void setNum(String num) {
    this.num = num;
  }

  public String getNum() {
    return num;
  }

  public void setCode(BigDecimal code) {
    this.code = code;
  }

  public BigDecimal getCode() {
    return code;
  }

  @InstanceName
  @DependsOnProperties({"fullName", "num", "numCod"})
  public String getInstanceName() {
    return String.format("%s :: %s :: %s", getFullName(), getNum(), getNumCod());
  }
}