package com.company.nfp.entity.dictionaries.product;

import com.company.nfp.entity.mapped_super_class.TenantNamed;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;

@JmixEntity
@Table(name = "NFP_PRODUCT_SUBGROUP", indexes = {
        @Index(name = "IDX_NFPPRODUCTSUB_PRODUCTGROUP", columnList = "PRODUCT_GROUP_ID")
})
@Entity(name = "nfp_ProductSubgroup")
public class ProductSubgroup extends TenantNamed {
    @JoinColumn(name = "PRODUCT_GROUP_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private ProductGroup productGroup;

    public ProductGroup getProductGroup() {
        return productGroup;
    }

    public void setProductGroup(ProductGroup productGroup) {
        this.productGroup = productGroup;
    }

    @InstanceName
    @DependsOnProperties({"fullName"})
    public String getInstanceName() {
        return String.format("%s", getFullName());
    }
}