package com.company.nfp.entity.dictionaries.product;

import com.company.nfp.entity.mapped_super_class.Named;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.math.BigDecimal;

@JmixEntity
@Table(name = "NFP_UNIT")
@Entity(name = "nfp_Unit")
public class Unit extends Named {
    @Column(name = "CODE")
    private Long code;

    @Column(name = "NUM")
    private String num;

    @Column(name = "LAT_NAME")
    private String latName;

    @Column(name = "QUANTITY", precision = 19, scale = 2)
    private BigDecimal quantity;

    public BigDecimal getQuantity() {
        return quantity;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    public String getLatName() {
        return latName;
    }

    public void setLatName(String latName) {
        this.latName = latName;
    }

    public String getNum() {
        return num;
    }

    public void setNum(String num) {
        this.num = num;
    }

    public Long getCode() {
        return code;
    }

    public void setCode(Long code) {
        this.code = code;
    }

    @InstanceName
    @DependsOnProperties({"fullName"})
    public String getInstanceName() {
        return String.format("%s", getFullName());
    }
}