package com.company.nfp.entity.dictionaries.prro;

import com.company.nfp.entity.dictionaries.employee.Employee;
import com.company.nfp.entity.mapped_super_class.TenantNamed;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.time.LocalDate;

@JmixEntity
@Table(name = "NFP_PRRO", indexes = {
        @Index(name = "IDX_NFP_PRRO_EMPLOYEE", columnList = "EMPLOYEE_ID")
})
@Entity(name = "nfp_Prro")
public class Prro extends TenantNamed {
    @NotNull
    @Column(name = "HOST", nullable = false)
    private String host;

    @Column(name = "PORT", nullable = false)
    @NotNull
    private String port;

    @Column(name = "PATH_RECEIPT", nullable = false)
    @NotNull
    private String pathReceipt;

    @JoinColumn(name = "EMPLOYEE_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private Employee employee;

    @Column(name = "ACTIVE_UNTIL")
    private LocalDate activeUntil;

    public LocalDate getActiveUntil() {
        return activeUntil;
    }

    public void setActiveUntil(LocalDate activeUntil) {
        this.activeUntil = activeUntil;
    }

    public Employee getEmployee() {
        return employee;
    }

    public void setEmployee(Employee employee) {
        this.employee = employee;
    }

    public String getPathReceipt() {
        return pathReceipt;
    }

    public void setPathReceipt(String pathReceipt) {
        this.pathReceipt = pathReceipt;
    }

    public String getPort() {
        return port;
    }

    public void setPort(String port) {
        this.port = port;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }
}