package com.company.nfp.entity.source.product;

import com.company.nfp.entity.dictionaries.product.Product;
import com.company.nfp.entity.mapped_super_class.TenantAttribute;
import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.List;

@JmixEntity
@Table(name = "NFP_GOOD_DETAIL", indexes = {
        @Index(name = "IDX_NFP_GOOD_DETAIL_GOOD", columnList = "GOOD_ID"),
        @Index(name = "IDX_NFP_GOOD_DETAIL_PRODUCT", columnList = "PRODUCT_ID")
})
@Entity(name = "nfp_GoodDetail")
public class GoodDetail extends TenantAttribute {
    @Column(name = "NUMBER_IN_ORDER")
    private Integer numberInOrder;

    @JoinColumn(name = "PRODUCT_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Product product;

    @Column(name = "BALANCE", precision = 19, scale = 3)
    private BigDecimal balance;

    @Column(name = "QUANTITY", precision = 19, scale = 3)
    private BigDecimal quantity;

    @Column(name = "BAL_QUANTITY", precision = 19, scale = 3)
    private BigDecimal balQuantity;

    @Column(name = "COST_PRICE", precision = 19, scale = 2)
    private BigDecimal costPrice;

    @Column(name = "COST_WITHOUT_TAX", precision = 19, scale = 6)
    private BigDecimal costWithoutTax;

    @Column(name = "TAX", precision = 19, scale = 6)
    private BigDecimal tax;

    @Column(name = "COST", precision = 19, scale = 2)
    private BigDecimal cost;

    @Column(name = "SUM_PRICE", precision = 19, scale = 2)
    private BigDecimal sumPrice;

    @Column(name = "SUM_WITHOUT_TAX", precision = 19, scale = 6)
    private BigDecimal sumWithoutTax;

    @Column(name = "SUM_TAX", precision = 19, scale = 6)
    private BigDecimal sumTax;

    @Column(name = "SUM_", precision = 19, scale = 2)
    private BigDecimal sum;

    @JoinColumn(name = "GOOD_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Good good;

    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "goodDetail")
    private List<GoodDetailExcise> excise;

    public BigDecimal getBalQuantity() {
        return balQuantity;
    }

    public void setBalQuantity(BigDecimal balQuantity) {
        this.balQuantity = balQuantity;
    }

    public List<GoodDetailExcise> getExcise() {
        return excise;
    }

    public void setExcise(List<GoodDetailExcise> excise) {
        this.excise = excise;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public Good getGood() {
        return good;
    }

    public void setGood(Good good) {
        this.good = good;
    }

    public BigDecimal getSum() {
        return sum;
    }

    public void setSum(BigDecimal sum) {
        this.sum = sum;
    }

    public BigDecimal getSumTax() {
        return sumTax;
    }

    public void setSumTax(BigDecimal sumTax) {
        this.sumTax = sumTax;
    }

    public BigDecimal getSumWithoutTax() {
        return sumWithoutTax;
    }

    public void setSumWithoutTax(BigDecimal sumWithoutTax) {
        this.sumWithoutTax = sumWithoutTax;
    }

    public BigDecimal getSumPrice() {
        return sumPrice;
    }

    public void setSumPrice(BigDecimal sumPrice) {
        this.sumPrice = sumPrice;
    }

    public BigDecimal getCost() {
        return cost;
    }

    public void setCost(BigDecimal cost) {
        this.cost = cost;
    }

    public BigDecimal getTax() {
        return tax;
    }

    public void setTax(BigDecimal tax) {
        this.tax = tax;
    }

    public BigDecimal getCostWithoutTax() {
        return costWithoutTax;
    }

    public void setCostWithoutTax(BigDecimal costWithoutTax) {
        this.costWithoutTax = costWithoutTax;
    }

    public BigDecimal getCostPrice() {
        return costPrice;
    }

    public void setCostPrice(BigDecimal costPrice) {
        this.costPrice = costPrice;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    public BigDecimal getBalance() {
        return balance;
    }

    public void setBalance(BigDecimal balance) {
        this.balance = balance;
    }

    public Integer getNumberInOrder() {
        return numberInOrder;
    }

    public void setNumberInOrder(Integer numberInOrder) {
        this.numberInOrder = numberInOrder;
    }
}