package com.company.nfp.screen.prro.check.check_view.checkview;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import io.jmix.ui.component.Image;
import io.jmix.ui.component.StreamResource;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

@UiController("nfp_CheckViewScreen")
@UiDescriptor("check-view-screen.xml")
public class CheckViewScreen extends Screen {
    private String checkString = null;
    @Autowired
    private Image qrCodeImage;

    public void setCheckString(String checkString) {
        this.checkString = checkString;
    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) throws IOException, WriterException {
        BufferedImage bmp = encodeToQrCode(checkString);
        var bos = new ByteArrayOutputStream();
        assert bmp != null;
        ImageIO.write(bmp, "jpg", bos);
        var bytes = bos.toByteArray();
        var inputStream = new ByteArrayInputStream(bytes);
        qrCodeImage.setSource(StreamResource.class).setStreamSupplier(() -> inputStream);
    }

    private BufferedImage encodeToQrCode(String checkString) throws WriterException {
        var width = 450;
        var height = 450;
        var writer = new QRCodeWriter();
        BitMatrix matrix = null;
        try {
            matrix = writer.encode(checkString, BarcodeFormat.QR_CODE, width, height);
        } catch (WriterException e) {
            return null;
        }

        var bmp = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB); //createBitmap(width, height, Bitmap.Config.RGB_565)
        for (int x = 0; x < width; x++) {
            for (int y = 0; y < height; y++) {
                bmp.setRGB(x, y, matrix.get(x,y) ? 0xFF000000 : 0xFFFFFFFF);
            }
        }
        return bmp;

        //var array = writeImageToByteArray(bmp)

/*      // the QR code decode to the string
        var result = QRCodeReader().decode(
            BinaryBitmap(
                HybridBinarizer(
                    RGBLuminanceSource(
                        bmp.width, bmp.height,
                        bmp.getRGB(
                            0, 0, bmp.width, bmp.height, null, 0,
                            bmp.width
                        )
                    )
                )
            )
        )
        var bytes1 = result.text.toByteArray(charset("UTF-8"))*/
    }

}