package com.company.nfp.screen.prro.check.excise.excise;

import com.company.nfp.entity.source.product.GoodDetail;
import com.company.nfp.entity.source.product.GoodDetailExcise;
import io.jmix.core.DataManager;
import io.jmix.core.Messages;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.TextField;
import io.jmix.ui.component.TextInputField;
import io.jmix.ui.model.CollectionPropertyContainer;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;
import java.util.List;

@UiController("nfp_ExciseScreen")
@UiDescriptor("excise-screen.xml")
public class ExciseScreen extends Screen {
    private GoodDetail checkDetail;
    private BigDecimal quantity;
    private List<GoodDetailExcise> excises;
    @Autowired
    private TextField<String> exciseField;
    @Autowired
    private Messages messages;
    @Autowired
    private Notifications notifications;
    @Autowired
    private DataManager dataManager;
    @Autowired
    private CollectionPropertyContainer<GoodDetailExcise> excisesDc;

    public void setCheckDetail(GoodDetail checkDetail) {
        this.checkDetail = checkDetail;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        exciseField.setValue(null);
        exciseField.focus();
    }

    @Subscribe("exciseField")
    public void onExciseFieldEnterPress(TextInputField.EnterPressEvent event) {
        if (exciseField.getValue() != null) {
            if (exciseField.getValue().length() < 1 || exciseField.getValue().length() > 10) {
                notificationShow(messages.formatMessage("validator", "textField.size",
                        exciseField.getInputPrompt(), "1", "10"),
                        Notifications.NotificationType.WARNING);
                return;
            }
            var excise = dataManager.create(GoodDetailExcise.class);
            excise.setExcise(exciseField.getValue());
            excise.setGoodDetail(checkDetail);
            excisesDc.setItems(excises);
            quantity = quantity.subtract(BigDecimal.ONE);
            if (quantity.compareTo(BigDecimal.ZERO) == 0) {
                checkDetail.setExcise(excises);
                close(WINDOW_CLOSE_ACTION);
            }
            exciseField.setValue(null);
            exciseField.focus();
        }
    }

    /**
     * Show notification
     *
     * @param key              Message Bandle Key
     * @param notificationType Notification Type
     */
    private void notificationShow(String key, Notifications.NotificationType notificationType) {
        String message = messages.getMessage(key);
        notifications.create(notificationType)
                .withDescription(message)
                .show();
    }

}