package com.company.nfp.security;

import com.company.nfp.entity.RegEusPayer;
import com.company.nfp.entity.User;
import com.company.nfp.entity.dictionaries.acquirer.Acquirer;
import com.company.nfp.entity.dictionaries.bank.Bank;
import com.company.nfp.entity.dictionaries.counterparty.Counterparty;
import com.company.nfp.entity.dictionaries.counterparty.counterparty_account.CounterpartyAccount;
import com.company.nfp.entity.dictionaries.dpi.Dpi;
import com.company.nfp.entity.dictionaries.employee.Employee;
import com.company.nfp.entity.dictionaries.employee.income_signs.IncomeSigns;
import com.company.nfp.entity.dictionaries.employee.insured_person_categories.IPCategory;
import com.company.nfp.entity.dictionaries.employee.position.Position;
import com.company.nfp.entity.dictionaries.firm.*;
import com.company.nfp.entity.dictionaries.firm.firm_account.FirmAccount;
import com.company.nfp.entity.dictionaries.koatuu.Koatuu;
import com.company.nfp.entity.dictionaries.koatuu.KoatuuOld;
import com.company.nfp.entity.dictionaries.kved.Kved;
import com.company.nfp.entity.dictionaries.model_name.ModelName;
import com.company.nfp.entity.dictionaries.product.*;
import com.company.nfp.entity.dictionaries.prro.Prro;
import com.company.nfp.entity.dictionaries.service.Service;
import com.company.nfp.entity.dictionaries.software_version.SoftwareVersion;
import com.company.nfp.entity.dictionaries.stat.Stat;
import com.company.nfp.entity.source.product.Good;
import com.company.nfp.entity.source.product.GoodDetail;
import com.company.nfp.entity.source.product.GoodDetailExcise;
import com.company.nfp.entity.source.revaluation.Revaluation;
import io.jmix.reports.entity.*;
import io.jmix.reports.entity.wizard.ReportData;
import io.jmix.reports.entity.wizard.ReportRegion;
import io.jmix.security.model.EntityAttributePolicyAction;
import io.jmix.security.model.EntityPolicyAction;
import io.jmix.security.role.annotation.EntityAttributePolicy;
import io.jmix.security.role.annotation.EntityPolicy;
import io.jmix.security.role.annotation.ResourceRole;
import io.jmix.security.role.annotation.SpecificPolicy;
import io.jmix.securityui.role.annotation.MenuPolicy;
import io.jmix.securityui.role.annotation.ScreenPolicy;
import io.jmix.ui.entity.*;
import io.jmix.uidata.entity.FilterConfiguration;
import io.jmix.uidata.entity.UiSetting;
import io.jmix.uidata.entity.UiTablePresentation;

@ResourceRole(name = "Multitenant User", code = "multitenant-user")
public interface MultitenantUserRole {

    @MenuPolicy(menuIds = {"nfp_Firm.browse", "themeSettingsScreen", "nfp_Counterparty.browse", "nfp_Bank.browse", "nfp_ProductGroup.browse", "nfp_Employee.browse", "nfp_ProductSubgroup.browse", "nfp_Product.browse", "nfp_Good.browse", "nfp_Stat.browse", "nfp_GoodDetail.browse", "nfp_Prro.browse", "nfp_ShopOption.browse", "nfp_Revaluation.browse", "report_Report.browse", "report_ReportGroup.browse", "report_Report.run", "nfp_Service.browse"})
    @ScreenPolicy(screenIds = {"nfp_Firm.browse", "themeSettingsScreen", "nfp_Firm.edit", "nfp_FirmKved.edit", "nfp_LoginScreen", "nfp_MainScreen", "nfp_Rro.edit", "nfp_RegVatPayer.edit", "nfp_RegSingleTaxPayer.edit", "nfp_RegEusPayer.edit", "nfp_Dpi.browse", "nfp_Dpi.edit", "nfp_Kved.browse", "nfp_Kved.edit", "nfp_ModelName.browse", "nfp_ModelName.edit", "nfp_Acquirer.browse", "nfp_Acquirer.edit", "nfp_SoftwareVersion.browse", "nfp_SoftwareVersion.edit", "nfp_Koatuu.browse", "nfp_Koatuu.edit", "nfp_KoatuuOld.browse", "nfp_KoatuuOld.edit", "nfp_Bank.browse", "nfp_Bank.edit", "nfp_Counterparty.browse", "nfp_Counterparty.edit", "nfp_CounterpartyAccount.edit", "nfp_Shop.edit", "nfp_Employee.browse", "nfp_Employee.edit", "nfp_IPCategory.browse", "nfp_IPCategory.edit", "nfp_IncomeSigns.browse", "nfp_IncomeSigns.edit", "nfp_Position.browse", "nfp_Position.edit", "nfp_Shop.browse", "nfp_ProductGroup.browse", "nfp_ProductGroup.edit", "nfp_ProductSubgroup.browse", "nfp_ProductSubgroup.edit", "nfp_Product.browse", "nfp_Product.edit", "nfp_Uktzed.browse", "nfp_Uktzed.edit", "nfp_Unit.browse", "nfp_Unit.edit", "nfp_FirmAccount.edit", "nfp_Good.browse", "nfp_Good.edit", "nfp_FirmAccount.browse", "nfp_GoodDetail.edit", "nfp_GoodDetailExcise.edit", "nfp_Stat.browse", "nfp_Stat.edit", "ui_AddConditionScreen", "ui_GroupFilterCondition.edit", "ui_JpqlFilterCondition.edit", "ui_PropertyFilterCondition.edit", "ui_DateIntervalDialog", "ui_UiDataFilterConfigurationModel.fragment", "ui_FilterConfigurationModel.fragment", "backgroundWorkProgressScreen", "inputDialog", "notFoundScreen", "selectValueDialog", "nfp_GoodDetail.browse", "nfp_Prro.browse", "nfp_Prro.edit", "nfp_User.browse", "nfp_ShopOption.browse", "nfp_ShopOption.edit", "nfp_Revaluation.browse", "nfp_Revaluation.edit", "report_Report.browse", "report_ReportGroup.browse", "report_Report.run", "report_BandDefinitionEditor.fragment", "report_ScriptEditor.dialog", "report_ReportGroup.edit", "report_ReportInputParameter.edit", "report_Report.edit", "report_ReportEditGeneral.fragment", "report_ReportEditLocales.fragment", "report_ReportEditParameters.fragment", "report_ReportEditSecurity.fragment", "report_ReportEditTemplates.fragment", "report_ReportEditValueFormats.fragment", "report_ReportImport.dialog", "report_InputParameters.dialog", "report_InputParameters.fragment", "report_QueryParameter.edit", "report_EntityTree.fragment", "report_Region.edit", "report_ReportEntityTree.lookup", "report_ReportWizardCreator", "report_DetailsStep.fragment", "report_QueryStep.fragment", "report_RegionStep.fragment", "report_SaveStep.fragment", "report_ReportValueFormat.edit", "report_PivotTableAggregation.edit", "report_PivotTableProperty.edit", "report_ChartEdit.fragment", "report_PivotTableEdit.fragment", "report_ReportTemplate.edit", "report_TableEdit.fragment", "nfp_Service.browse", "nfp_Service.edit"})
    void screens();

    @SpecificPolicy(resources = {"ui.loginToUi", "ui.filter.modifyJpqlCondition", "ui.presentations.global", "ui.filter.modifyConfiguration", "ui.filter.modifyGlobalConfiguration", "ui.bulkEdit.enabled"})
    void specific();

    @EntityAttributePolicy(entityClass = Rro.class, attributes = {"firm", "fiscalNumber",
            "registrationDate", "applicationScope", "lastBookNumber", "lastBookRegistrationDate",
            "cancellationRegistrationDate", "modelName", "acquirer", "commissioningDate",
            "softwareVersion", "factoryNumber",
            "expiryDate", "manufactureDate", "note", "objectName", "objectAddress",
            "note1", "koatuu", "koatuuOld"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Rro.class, actions = EntityPolicyAction.ALL)
    void rro();

    @EntityAttributePolicy(entityClass = Firm.class, attributes = "id", action = EntityAttributePolicyAction.VIEW)
    @EntityAttributePolicy(entityClass = Firm.class, attributes = {"fullName", "shortName", "taxpayerRegDate", "taxpayerRegNumber", "specialMode", "deregDate", "address", "phones", "firmKved", "headPosition", "headName", "headNameInText", "headNameInSign", "headShortName", "accountantName", "rro", "taxRateFo", "esv", "taxNumber", "regVatPayers", "taxationSystem", "currentLivingWage", "currentMinimumSalary", "regSingleTaxPayers", "regEusPayers", "generalSystemEsv", "generalSystemIncomeTax", "dpi", "headPhone", "accountantPhone", "firmEmail", "generalSystemMilitaryCollection", "shops", "ipn", "firmAccount", "isVatPayer"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Firm.class, actions = EntityPolicyAction.ALL)
    void firm();

    @EntityAttributePolicy(entityClass = FirmKved.class, attributes = {"firm", "kved",
            "main"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = FirmKved.class, actions = EntityPolicyAction.ALL)
    void firmKved();

    @EntityAttributePolicy(entityClass = RegVatPayer.class, attributes = {"firm", "ipn",
            "taxpayerRegDate", "regPeriod", "cancellationRegDate", "cancellationReason",
            "annulmentReason", "regSpecialRegimeDate"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = RegVatPayer.class, actions = EntityPolicyAction.ALL)
    void regVatPayer();

    @EntityAttributePolicy(entityClass = RegSingleTaxPayer.class, attributes = {"firm",
            "cancellationDate", "group", "rate",
            "toSimpleTaxDate"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = RegSingleTaxPayer.class, actions = EntityPolicyAction.ALL)
    void regSingleTaxPayer();

    @EntityAttributePolicy(entityClass = RegEusPayer.class, attributes = {"firm", "regDate",
            "regNumberEusPayer", "riskClassProduction", "kvedAssigned",
            "deRegDate"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = RegEusPayer.class, actions = EntityPolicyAction.ALL)
    void regEusPayer();

    @EntityAttributePolicy(entityClass = Dpi.class, attributes = {"fullName", "shortName", "dpiCode",
            "edrpou"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Dpi.class, actions = EntityPolicyAction.READ)
    void dpi();

    @EntityAttributePolicy(entityClass = Kved.class, attributes = {"fullName", "shortName",
            "vedCode"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Kved.class, actions = EntityPolicyAction.READ)
    void kved();

    @EntityAttributePolicy(entityClass = ModelName.class, attributes = {"fullName",
            "shortName"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = ModelName.class, actions = EntityPolicyAction.READ)
    void modelName();

    @EntityAttributePolicy(entityClass = Acquirer.class, attributes = {"fullName",
            "shortName"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Acquirer.class, actions = EntityPolicyAction.READ)
    void acquirer();

    @EntityAttributePolicy(entityClass = SoftwareVersion.class, attributes = {"fullName",
            "shortName"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = SoftwareVersion.class, actions = EntityPolicyAction.READ)
    void softwareVersion();

    @EntityAttributePolicy(entityClass = Koatuu.class, attributes = {"fullName",
            "shortName", "level1", "level2", "level3", "level4", "levelAdd",
            "objectCategory"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Koatuu.class, actions = EntityPolicyAction.READ)
    void koatuu();

    @EntityAttributePolicy(entityClass = KoatuuOld.class, attributes = {"fullName",
            "shortName", "code", "catCod", "num", "numCod", "numCt",
            "shortNum"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = KoatuuOld.class, actions = EntityPolicyAction.READ)
    void koatuuOld();

    @EntityAttributePolicy(entityClass = Bank.class, attributes = {"fullName",
            "shortName", "mfo"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Bank.class, actions = EntityPolicyAction.ALL)
    void bank();

    @EntityAttributePolicy(entityClass = Counterparty.class, attributes = {"fullName", "shortName", "accountantName", "actualPhone", "counterpartyAccounts", "address", "basisAct", "branch", "certificateNumber", "certificatePayerTaxNumber", "codeSourceRegister", "edrpou", "headNameInSign", "headNameInText", "headPosition", "headShortName", "ipn", "isAn", "isVatPayer", "phone", "headName"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Counterparty.class, actions = EntityPolicyAction.ALL)
    void counterparty();

    @EntityAttributePolicy(entityClass = CounterpartyAccount.class, attributes = {"counterparty",
            "bank", "account", "main"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = CounterpartyAccount.class, actions = EntityPolicyAction.ALL)
    void counterpartyAccount();

    @EntityPolicy(entityClass = Shop.class, actions = EntityPolicyAction.ALL)
    @EntityAttributePolicy(entityClass = Shop.class, attributes = {"fullName", "shortName", "employees", "address", "main"}, action = EntityAttributePolicyAction.MODIFY)
    void shop();

    @EntityAttributePolicy(entityClass = Employee.class, attributes = {"phone", "fullName", "shortName", "address", "shop", "idNum", "ipCat", "incomeSigns", "position", "salary", "user", "main"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Employee.class, actions = EntityPolicyAction.ALL)
    void employee();

    @EntityAttributePolicy(entityClass = IPCategory.class, attributes = {"code",
            "name"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = IPCategory.class, actions = EntityPolicyAction.READ)
    void ipCategory();

    @EntityAttributePolicy(entityClass = IncomeSigns.class, attributes = {"code",
            "shortName", "fullName", "num", "dateEnd", "dateBeg"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = IncomeSigns.class, actions = EntityPolicyAction.READ)
    void incomeSigns();

    @EntityAttributePolicy(entityClass = Position.class, attributes = {"code",
            "shortName", "fullName", "codekp", "dateBeg", "dateEnd", "zkpp"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Position.class, actions = EntityPolicyAction.READ)
    void position();

    @EntityAttributePolicy(entityClass = ProductGroup.class, attributes = {"fullName", "shortName"},
            action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ProductGroup.class, actions = EntityPolicyAction.ALL)
    void productGroup();

    @EntityAttributePolicy(entityClass = Product.class, attributes = "id", action = EntityAttributePolicyAction.VIEW)
    @EntityAttributePolicy(entityClass = Product.class, attributes = {"fullName", "shortName", "barcode", "code", "vatGroup", "isExcise", "isService", "productSubgroup", "uktzed", "unit", "balance", "costPrice", "costPurchase"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Product.class, actions = EntityPolicyAction.ALL)
    void product();

    @EntityAttributePolicy(entityClass = ProductSubgroup.class, attributes = {"fullName", "shortName", "productGroup"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ProductSubgroup.class, actions = EntityPolicyAction.ALL)
    void productSubgroup();

    @EntityPolicy(entityClass = Uktzed.class, actions = EntityPolicyAction.READ)
    @EntityAttributePolicy(entityClass = Uktzed.class, attributes = {"fullName", "shortName", "code", "num"}, action = EntityAttributePolicyAction.VIEW)
    void uktzed();

    @EntityAttributePolicy(entityClass = Unit.class, attributes = {"fullName", "shortName", "code", "num", "latName", "quantity"}, action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Unit.class, actions = EntityPolicyAction.READ)
    void unit();

    @EntityAttributePolicy(entityClass = User.class, attributes = "*", action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = User.class, actions = EntityPolicyAction.READ)
    void user();

    @EntityAttributePolicy(entityClass = FirmAccount.class, attributes = {"id", "account", "main", "bankCooperation", "bank", "userId", "accessToken", "firm"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = FirmAccount.class, actions = EntityPolicyAction.ALL)
    void firmAccount();

    @EntityAttributePolicy(entityClass = Good.class, attributes = {"num", "docSubType", "docSubTypeString", "fn", "qr", "dfsLink", "change", "checkText", "sumPrice", "sumWithoutTax", "sumTax", "sum", "balWithoutTax", "balTax", "bal", "difference", "sumInWords"}, action = EntityAttributePolicyAction.VIEW)
    @EntityAttributePolicy(entityClass = Good.class, attributes = {"accountingType", "sourceGoodType", "pnIsThere", "counterparty", "firmAccount", "shop", "employee", "stat", "goodDetail", "number", "date", "reason", "firmRepresentative", "customerRepresentative", "place", "email", "byCash", "byCredit", "byCheck", "byCard", "byBonuses", "orderDoc", "payer", "taxInvoiceNumber", "taxInvoiceDate", "contractNumber", "contractDate", "saleCondition", "accepted", "proxy", "extraCharge", "comment", "service"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Good.class, actions = EntityPolicyAction.ALL)
    void good();

    @EntityAttributePolicy(entityClass = GoodDetail.class, attributes = {"product", "balance", "quantity", "costPrice", "costWithoutTax", "tax", "cost", "sumPrice", "sumWithoutTax", "sumTax", "sum", "good", "excise", "balQuantity"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityAttributePolicy(entityClass = GoodDetail.class, attributes = "numberInOrder", action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = GoodDetail.class, actions = EntityPolicyAction.ALL)
    void goodDetail();

    @EntityAttributePolicy(entityClass = GoodDetailExcise.class, attributes = {"excise", "goodDetail"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = GoodDetailExcise.class, actions = EntityPolicyAction.ALL)
    void goodDetailExcise();

    @EntityAttributePolicy(entityClass = Stat.class, attributes = {"fullName", "shortName", "direction"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Stat.class, actions = EntityPolicyAction.ALL)
    void stat();

    @EntityAttributePolicy(entityClass = FilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = FilterCondition.class, actions = EntityPolicyAction.ALL)
    void filterCondition();

    @EntityAttributePolicy(entityClass = FilterConfiguration.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = FilterConfiguration.class, actions = EntityPolicyAction.ALL)
    void filterConfiguration();

    @EntityAttributePolicy(entityClass = FilterValueComponent.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = FilterValueComponent.class, actions = EntityPolicyAction.ALL)
    void filterValueComponent();

    @EntityAttributePolicy(entityClass = GroupFilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = GroupFilterCondition.class, actions = EntityPolicyAction.ALL)
    void groupFilterCondition();

    @EntityAttributePolicy(entityClass = HeaderFilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = HeaderFilterCondition.class, actions = EntityPolicyAction.ALL)
    void headerFilterCondition();

    @EntityAttributePolicy(entityClass = JpqlFilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = JpqlFilterCondition.class, actions = EntityPolicyAction.ALL)
    void jpqlFilterCondition();

    @EntityAttributePolicy(entityClass = LogicalFilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = LogicalFilterCondition.class, actions = EntityPolicyAction.ALL)
    void logicalFilterCondition();

    @EntityAttributePolicy(entityClass = PropertyFilterCondition.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = PropertyFilterCondition.class, actions = EntityPolicyAction.ALL)
    void propertyFilterCondition();

    @EntityAttributePolicy(entityClass = UiTablePresentation.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = UiTablePresentation.class, actions = EntityPolicyAction.ALL)
    void uiTablePresentation();

    @EntityPolicy(entityClass = UiSetting.class, actions = EntityPolicyAction.ALL)
    @EntityAttributePolicy(entityClass = UiSetting.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    void uiSetting();

    @EntityAttributePolicy(entityClass = Prro.class, attributes = {"fullName", "shortName", "host", "port", "pathReceipt", "employee", "activeUntil"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Prro.class, actions = EntityPolicyAction.ALL)
    void prro();

    @EntityPolicy(entityClass = ShopOption.class, actions = EntityPolicyAction.ALL)
    @EntityAttributePolicy(entityClass = ShopOption.class, attributes = {"shop", "salesMethod"}, action = EntityAttributePolicyAction.MODIFY)
    void shopOption();

    @EntityPolicy(entityClass = Revaluation.class, actions = EntityPolicyAction.ALL)
    @EntityAttributePolicy(entityClass = Revaluation.class, attributes = {"sourceRevaluationType", "firm", "product", "date", "costPrice", "oldCost", "cost"}, action = EntityAttributePolicyAction.MODIFY)
    void revaluation();

    @EntityAttributePolicy(entityClass = Report.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Report.class, actions = EntityPolicyAction.ALL)
    void report();

    @EntityAttributePolicy(entityClass = ReportData.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportData.class, actions = EntityPolicyAction.ALL)
    void reportData();

    @EntityAttributePolicy(entityClass = ReportExecution.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportExecution.class, actions = EntityPolicyAction.ALL)
    void reportExecution();

    @EntityAttributePolicy(entityClass = ReportGroup.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportGroup.class, actions = EntityPolicyAction.ALL)
    void reportGroup();

    @EntityAttributePolicy(entityClass = ReportInputParameter.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportInputParameter.class, actions = EntityPolicyAction.ALL)
    void reportInputParameter();

    @EntityPolicy(entityClass = ReportRegion.class, actions = EntityPolicyAction.ALL)
    @EntityAttributePolicy(entityClass = ReportRegion.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    void reportRegion();

    @EntityAttributePolicy(entityClass = ReportRole.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportRole.class, actions = EntityPolicyAction.ALL)
    void reportRole();

    @EntityAttributePolicy(entityClass = ReportScreen.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportScreen.class, actions = EntityPolicyAction.ALL)
    void reportScreen();

    @EntityAttributePolicy(entityClass = ReportTemplate.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportTemplate.class, actions = EntityPolicyAction.ALL)
    void reportTemplate();

    @EntityAttributePolicy(entityClass = ReportValueFormat.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ReportValueFormat.class, actions = EntityPolicyAction.ALL)
    void reportValueFormat();

    @EntityAttributePolicy(entityClass = Service.class, attributes = "id", action = EntityAttributePolicyAction.VIEW)
    @EntityAttributePolicy(entityClass = Service.class, attributes = {"fullName", "shortName"}, action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Service.class, actions = EntityPolicyAction.ALL)
    void service();
}